#!/bin/bash
# tmw-on.sh 0.2
# a simple "Who's on"-Skript written for Linux and the game
# "the Mana World" (http://themanaworld.org).
#
# Put the name of your friends in the list, and the skript
# will check if they are online and trowh their names out
# if they are online, each time the script will be executed.
# It is designed for use with desktop applets, such as 
# Superkaramba or the stdin-Plasmoid from KDE4, which
# executes this script in intervalls.
# Please use a fixed-width font (like monospace) for display,
# except u use left align, because align is done with spaces.
#
# If you are having trouble, wishes or bugs please post them
# in the forum: 
# http://forums.themanaworld.org/viewtopic.php?f=12&t=6338 
# or whisper to Terwarf ingame.
#
# Have fun!
# _________________
# Settings Section: 
#
# List of friends
# U can extend the list as wide as you want, following
# the existing scheme of "search + Number".
# When u are done, u have to tweak the value "searchMax"
# to the highest used number in list.
#
search1="Terwarf"
search2="anotherName"
search3="anotherOneHere"
searchMax=3

# Language & String settings
#
# Error string if download failes
strError="Download\n failed"
# string before user count
strUserBef="-"
# string behind user count
strUserBeh="-"

# Appereance settings
#
# Align of the Text: (l/c/r)
appAlign="c"
# string to show as title
appStrTitleLine1="TMW"
appStrTitleLine2="online"
# Show title? (y/n)
appShowTitle="y"
# Show number of online players? (y/n)
appShowNumber="y"
# Seperate number of online players from list? (y/n)
appSepeNumber="y"
# Always center number of online players? (y/n)
# (if "n" is given, number will be treated
# like the rest of the list)
appAlwCenNum="n"
# Fixed size (0-99)
# Here you can give the output a fixed size, so
# that the width of the applet won't change.
# Give the amount of chars that should be displayed,
# too long names will be cutted.
# A value of "0" disables Fixed size.
appFixedSize="20"

# File settings
#
# Name of the Temp-file
filTmp="/tmp/tmw-on-tmp"


# ______________________________________
# End of settings 
#

function alignRight {
  # usage: alignRight string lenght
  echo $1 | awk '{ printf("%'$2's\n", $0) }'
}
function alignCenter {
  # usage: alignCenter string lenght
  text=$1
  spacesMissing=$(( $2 - ${#text} ))
    while [ "$spacesMissing" -gt "1" ]; do
      text=" $text "
      let spacesMissing=spacesMissing-2
    done
  echo "$text"
}

counter=1
wget -O "$filTmp" http://server.themanaworld.org/online.txt &> /dev/null

if [ $? == 0 ]; then
  if [ $appFixedSize == "0" ]; then
    # search for the longest online Name
    nameLongest=0
    if [ "$appShowNumber" == "y" ]; then
      nameLongest=$(( ${#strUserBef} + ${#strUserBeh} + 3 ))
    fi
    while [ $counter -le $searchMax ]; do
	var="search$counter"
	nameAct="${!var}"
	nameSpaced="$nameAct"
	num="${#nameSpaced}"
	while [ "$num" -lt "30" ]; do
	  nameSpaced="$nameSpaced "
	  num="${#nameSpaced}"
	done
	grep -x "$nameSpaced" "$filTmp" &> /dev/null
	if [ "$?" == "0" ]; then
	  nameActLenght="${#nameAct}"
	  if [ "$nameActLenght" -gt "$nameLongest" ]; then
	    nameLongest="$nameActLenght"
	  fi
	fi
	let counter=counter+1
    done
  else
    # fixed with enabled
    nameLongest=$appFixedSize
  fi

  # show title
  if [ $appShowTitle == "y" ]; then
    if [ $appAlign == "c" ]; then
      alignCenter "$appStrTitleLine1" $nameLongest
      alignCenter "$appStrTitleLine2" $nameLongest
      echo ""
    elif [ $appAlign == "r" ]; then
      alignRight "$appStrTitleLine1" $nameLongest
      alignRight "$appStrTitleLine2" $nameLongest
      echo ""
    else
      echo "$appStrTitleLine1"
      echo "$appStrTitleLine2"
      echo ""
    fi
  fi

  # give out the names
  counter=1
  while [ $counter -le $searchMax ]; do
      var="search$counter"
      nameAct="${!var}"
      zeile="${!var}"
      num="${#zeile}"
      while [ "$num" -lt "30" ]; do
	zeile="$zeile "
	num="${#zeile}"
      done
      grep -x "$zeile" "$filTmp" &> /dev/null
      if [ "$?" == "0" ]; then
	# Cut name if needed & size is fixed
	if [ $appFixedSize != "0" ]; then
	  if [ ${#nameAct} -gt $appFixedSize ]; then
	    nameAct=$(echo $nameAct | awk '{ printf("%s\n", substr($0,0,'$appFixedSize-3')) }')
	    nameAct="$nameAct..."
	  fi
	fi # now let's give it out
	if   [ "$appAlign" == "c" ]; then
	  alignCenter "$nameAct" $nameLongest
	elif [ "$appAlign" == "r" ]; then
	  alignRight  "$nameAct" $nameLongest
	else
	  echo "$nameAct"
	fi
      fi
      let counter=counter+1 
  done

  # show online count
  if [ $appShowNumber == "y" ]; then
    userCount=$(grep "users are online" "$filTmp" | sed 's/ users are online.//' -)
    userCount="$strUserBef$userCount$strUserBeh"
    if [ "$appSepeNumber" == "y" ]; then
      echo ""
    fi

    if [ "$appAlwCenNum" == "y" ]; then
      alignCenter $userCount $nameLongest
    else
      if   [ "$appAlign" == "c" ]; then
	alignCenter "$userCount" $nameLongest
      elif [ "$appAlign" == "r" ]; then
	alignRight  "$userCount" $nameLongest
      else
	echo "$userCount"
      fi
    fi
  fi
  rm "$filTmp"

else

  # error case
  if [ $appShowTitle == "y" ]; then
    echo "  $appStrTitleLine1"
    echo " $appStrTitleLine2"
    echo ""
  fi
  echo -e "$strError"

fi